/* de33d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__33 = 33;

/* Subroutine */ int de33d_c(S_fp f, integer *m, integer *iorder,
        doublereal *xn, doublereal *yn, doublereal *h__, doublereal *df,
        doublereal *x, doublereal *y, doublereal *rs, doublereal *rf,
        doublereal *r__, integer *ierr)
{
    /* Initialized data */

    static doublereal d__[45] = { 1.,1.,-2.,1.,-3.,3.,1.,-4.,6.,-4.,1.,-5.,
            10.,-10.,5.,1.,-6.,15.,-20.,15.,-6.,1.,-7.,21.,-35.,35.,-21.,7.,
            1.,-8.,28.,-56.,70.,-56.,28.,-8.,1.,-9.,36.,-84.,126.,-126.,84.,
            -36.,9. };
    static doublereal c__[10] = { 1.,.5,.4166666666666667,.375,
            .3486111111111111,.3298611111111111,.3155919312169312,
            .3052662037037037,.2948680004409171,.149188850308642 };

    /* System generated locals */
    integer df_dim1, df_offset, y_dim1, y_offset, i__1, i__2, i__3, i__4;

    /* Local variables */
    static integer i__, j, k, l;
    extern /* Subroutine */ int de28ds_c(integer *, integer *, doublereal *,
            doublereal *, doublereal *), utde13_c(integer *, integer *);
    static integer j1, k1;
    static doublereal r1;
    static integer io;

#define y_ref(a_1,a_2) y[(a_2)*y_dim1 + a_1]
#define df_ref(a_1,a_2) df[(a_2)*df_dim1 + a_1]

    /* Parameter adjustments */
    --r__;
    --rf;
    --rs;
    y_dim1 = *m;
    y_offset = 1 + y_dim1 * 1;
    y -= y_offset;
    df_dim1 = *m;
    df_offset = 1 + df_dim1 * 1;
    df -= df_offset;
    --yn;
    --x;

    /* Function Body */
    *ierr = 0;
    io = *iorder;
    if (*iorder <= 10) {
        goto L1;
    }
    *ierr = 1;
    io = 10;
L1:
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        y_ref(i__, 1) = yn[i__];
/* L2: */
    }
    x[1] = *xn;
    (*f)(&x[1], &y_ref(1, 1), &df_ref(1, 1), m);
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        df_ref(i__, 1) = df_ref(i__, 1) * *h__;
        rs[i__] = df_ref(i__, 1);
/* L3: */
    }
    if (*iorder == 1) {
        goto L13;
    }
    i__1 = io;
    for (k = 2; k <= i__1; ++k) {
        x[k] = x[k - 1] + *h__;
/* L4: */
    }
    i__1 = io;
    for (j = 2; j <= i__1; ++j) {
        j1 = j - 1;
        i__2 = j;
        for (k = 2; k <= i__2; ++k) {
            k1 = k - 1;
            i__3 = *m;
            for (i__ = 1; i__ <= i__3; ++i__) {
                y_ref(i__, k) = y_ref(i__, k1);
                i__4 = j1;
                for (l = 1; l <= i__4; ++l) {
                    y_ref(i__, k) = y_ref(i__, k) +
                            df_ref(i__, l) * c__[l - 1];
/* L5: */
                }
/* L6: */
            }
            (*f)(&x[k], &y_ref(1, k), &rf[1], m);
            i__3 = *m;
            for (i__ = 1; i__ <= i__3; ++i__) {
                rf[i__] *= *h__;
/* L7: */
            }
            if (k == j) {
                j1 = j;
            }
            de28ds_c(m, &j1, &rf[1], &df[df_offset], &r__[1]);
/* L8: */
        }
        i__2 = *m;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i__3 = j;
            for (l = 2; l <= i__3; ++l) {
                r1 = 0.;
                i__4 = j;
                for (k = l; k <= i__4; ++k) {
                    k1 = (j - 1) * (j - 2) / 2 + k - l + 1;
                    r1 += df_ref(i__, k) * d__[k1 - 1];
/* L9: */
                }
                df_ref(i__, l) = r1;
/* L10: */
            }
            df_ref(i__, 1) = rs[i__];
/* L11: */
        }
/* L12: */
    }
L13:
    if (*ierr != 0) {
        utde13_c(ierr, &c__33);
    }
    return 0;
} /* de33d_c */

#undef df_ref
#undef y_ref
